package eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter;

import eu.ruekov.ruakij.LinkedBeaconTeleporters.Function;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.Main;
import org.bukkit.Location;

import java.util.ArrayList;
import java.util.List;

/**
 * Describes a placed-beacon-teleporter in the world
 */
public abstract class LinkedBeaconTeleporter {

    // Persistent id for linked-beacons
    public String teleporterId;

    // List of all linkedBeaconTeleporters with same teleporterId (real Type is usually ..Block, because linked Items are temporary constructs are useless)
    protected List<LinkedBeaconTeleporter> linkedBeaconTeleporters = new ArrayList<>();

    LinkedBeaconTeleporter(){
        this.teleporterId = Function.randomString("abcdefghijklmnopqrstuvwxyz0123456789", 10);

        linkedBeaconTeleporters = new ArrayList<>();
    }
    public LinkedBeaconTeleporter(String teleporterId){
        this.teleporterId = teleporterId;

        // Check if id exists
        linkedBeaconTeleporters = LinkedBeaconTeleporterManager.placedLBTsById.get(this.teleporterId());
        if(linkedBeaconTeleporters == null){
            // Create empty if not found
            linkedBeaconTeleporters = new ArrayList<>();
        }
    }

    public String teleporterId(){
        return teleporterId;
    }

    public List<LinkedBeaconTeleporter> linkedBeaconTeleporters(){
        return linkedBeaconTeleporters;
    }
}
